﻿Public Class frmHVBattleTimer
    Dim intLaunchMode, intNotifyMinutes As Integer
    Dim blnStartTimer, blnCancel, blnNotify As Boolean
    Dim dateHVBattle As Date

    Public Property launchMode() As Integer
        Get
            Return intLaunchMode
        End Get
        Set(ByVal value As Integer)
            intLaunchMode = value
        End Set
    End Property

    Public Property NotifyMinutes() As Integer
        Get
            Return intNotifyMinutes
        End Get
        Set(ByVal value As Integer)
            intNotifyMinutes = value
        End Set
    End Property

    Public ReadOnly Property EnableTimer() As Boolean
        Get
            Return blnStartTimer
        End Get
    End Property

    Public ReadOnly Property Canceled() As Boolean
        Get
            Return blnCancel
        End Get
    End Property

    Public Property NotifyEnabled() As Boolean
        Get
            Return blnNotify
        End Get
        Set(ByVal value As Boolean)
            blnNotify = value
        End Set
    End Property

    Public ReadOnly Property NextBattle() As Date
        Get
            Return dateHVBattle
        End Get
    End Property

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        ' If default was selected, make note
        If intLaunchMode < 0 Then
            intLaunchMode = 0
        End If

        ' Next HV Battle will start in 1 hour
        dateHVBattle = Now.AddHours(1.0)

        ' Is Notification on?
        blnNotify = chkReminder.Checked
        intNotifyMinutes = CInt(numMinutes.Value)

        ' We're ready to start the timer
        blnStartTimer = True

        ' We are done
        Me.Close()
    End Sub

    Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click
        ' Abort the Timer!
        blnStartTimer = False

        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        ' User didn't want to do anything
        blnCancel = True

        Me.Close()
    End Sub

    Private Sub frmHVBattleTimer_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    Private Sub frmHVBattleTimer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If intLaunchMode > 0 Then
            rdoNotify.Checked = True
        End If

        numMinutes.Value = CDec(intNotifyMinutes)

        chkReminder.Checked = blnNotify
        numMinutes.Enabled = blnNotify
        blnCancel = False
    End Sub

    Private Sub chkReminder_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkReminder.CheckedChanged
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        If newSender.Checked Then
            numMinutes.Enabled = True
        Else
            numMinutes.Enabled = False
        End If
    End Sub

    Private Sub rdoLaunchMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoBrowser.CheckedChanged, rdoNotify.CheckedChanged
        Dim newSender As Windows.Forms.RadioButton = CType(sender, Windows.Forms.RadioButton)
        If newSender.Checked Then
            If sender Is rdoBrowser Then
                rdoNotify.Checked = False
                intLaunchMode = BROWSERLAUNCH
            Else
                rdoBrowser.Checked = False
                intLaunchMode = NOTIFYLAUNCH
            End If
        End If
    End Sub
End Class