﻿Public Class frmOptions
    Dim strBrowserPath As String
    Dim blnCustomBrowser As Boolean

    ' Load Events
    Private Sub frmOptions_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Browser Stuff
        blnCustomBrowser = My.Settings.customBrowser
        If blnCustomBrowser Then
            strBrowserPath = My.Settings.browserPath
            txtBrowserPath.Text = strBrowserPath
        End If

        ' Update Stuff
        chkAutoUpdate.Checked = My.Settings.autoUpdate
        If chkAutoUpdate.Checked Then
            numUpdateDays.Enabled = True
        Else
            numUpdateDays.Enabled = False
        End If
        numUpdateDays.Value = CDec(My.Settings.autoUpdateDays)

        ' Behavior
        chkMinimize.Checked = My.Settings.minimizeInstead
        chkShowSplash.Checked = My.Settings.showSplash
        chkAutoBackup.Checked = My.Settings.autoBackup
        If chkAutoUpdate.Checked Then
            numAutoBackupDays.Enabled = True
        Else
            numAutoBackupDays.Enabled = False
        End If
        numAutoBackupDays.Value = CDec(My.Settings.autoBackupDays)

    End Sub

    Private Sub frmOptions_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    ' Save Settings
    Private Sub saveOptions()
        ' Browser Stuff
        My.Settings.customBrowser = blnCustomBrowser
        If blnCustomBrowser Then
            My.Settings.browserPath = strBrowserPath
        End If

        ' Update Stuff
        My.Settings.autoUpdate = chkAutoUpdate.Checked
        If chkAutoUpdate.Checked Then
            My.Settings.autoUpdateDays = CInt(numUpdateDays.Value)
        End If

        ' Behavior Stuff
        My.Settings.minimizeInstead = chkMinimize.Checked
        My.Settings.showSplash = chkShowSplash.Checked
        My.Settings.autoBackup = chkAutoBackup.Checked
        If chkAutoBackup.Checked Then
            My.Settings.autoBackupDays = CInt(numAutoBackupDays.Value)
        End If
    End Sub

    Private Sub chkAutoUpdate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAutoUpdate.CheckedChanged
        If chkAutoUpdate.Checked Then
            numUpdateDays.Enabled = True
        Else
            numUpdateDays.Enabled = False
        End If
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        saveOptions()
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub btnBrowseBrowser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseBrowser.Click
        Dim result As DialogResult

        ' Show Open File Dialog Box
        result = openFD.ShowDialog()

        ' Did they hit the cancel button?
        If Not result = Windows.Forms.DialogResult.Cancel Then
            ' Just in case
            If openFD.FileName.Length > 2 Then
                strBrowserPath = openFD.FileName
                blnCustomBrowser = True
                txtBrowserPath.Text = strBrowserPath
            End If
        End If
    End Sub

    Private Sub btnClearBrowser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearBrowser.Click
        blnCustomBrowser = False
        strBrowserPath = ""
        txtBrowserPath.Clear()
    End Sub

    Private Sub chkAutoBackup_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAutoBackup.CheckedChanged
        If chkAutoBackup.Checked Then
            numAutoBackupDays.Enabled = True
        Else
            numAutoBackupDays.Enabled = False
        End If
    End Sub

    ' For people who like to tab (like me), highlight the number when we enter the field
    Private Sub enterNumField(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAutoBackupDays.Enter, numUpdateDays.Enter
        Dim numField As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        numField.Select(0, 3)
    End Sub
End Class