﻿' Splash/About box
' Written by Paul "Sonic" Diederich
' Something I made back in College and maintained and adapted into new projects over
' the years.
' ==Usage==
' Create a new instance of this class and manipulate the properties before you display
' ==Properties==
' boolean:AllowLeave - If true, the user can close the dialog before the Timer expires
' boolean:Splash - If set to true, the dialog enters splash mode when displayed
' string:LoadingMessage - In splash mode, sets the loading message on the lower right corner
' boolean:RandomQuote - If true, generate a random quote as defined in the GenerateQuote() Subroutine
' string:Quote - Sets the text to display as the quote if RandomQuote is set to false

Public Class frmSplash
    Dim mblnSplash As Boolean
    Dim mblnAllowLeave As Boolean = True
    Dim mblnRandomQuote As Boolean = True
    Dim mstrQuote(29) As String

    Private Sub GenerateQuote()
        Dim intNum, intZombies As Integer
        intZombies = CInt((3399 * Rnd()) + 100)

        mstrQuote(0) = "MM Was Here!"
        mstrQuote(1) = "Make it Idot Proof and Someone will make a Better Idiot."
        mstrQuote(2) = "It doesn't matter if you win or lose, it's where you place the blame."
        mstrQuote(3) = "I would be delighted to offer any advice I can on understanding women...When I have some, I'll let you know."
        mstrQuote(4) = "I'm just here for the beer man."
        mstrQuote(5) = "2200 A test on Mercury results in failure when the planet unexpectedly splits in two. What was being researched has remained a closely guarded sex."
        mstrQuote(6) = "EH calc, reminding you of all the money you'll have to waste to get the good perks." & vbCrLf & "-niagatrats-"
        mstrQuote(7) = intZombies.ToString("#,#") & " zombies were harmed in the making of this program."
        mstrQuote(8) = "Death before Dishonor, but neither before my Anime!"
        mstrQuote(9) = "Its not called retreating, its called advancing in the opposite direction!"
        mstrQuote(10) = "There is no such thing as Overkill, only 'Open Fire' and 'I need to reload'."
        mstrQuote(11) = "TANK!"
        mstrQuote(12) = "Bombs are away, good day sir!"
        mstrQuote(13) = "How are you Gentlemen? All your Base are Belong to Us!"
        mstrQuote(14) = "If you're leaving scorch marks...you need a bigger gun."
        mstrQuote(15) = "Divine Buster, Extension!"
        mstrQuote(16) = "I wonder if the Cat got out yet?"
        mstrQuote(17) = "...and the fully armed nuclear warheads, are, of course, merely a courtesy detail."
        mstrQuote(18) = "Don't Blink"
        mstrQuote(19) = "Anthony's Law of Force: Don't force it; get a larger hammer."
        mstrQuote(20) = "WARNING: CPU is missing! Switching to Pre-Historic processing."
        mstrQuote(21) = "Ja, Ken, Pan!"
        mstrQuote(22) = "I blame the nanites."
        mstrQuote(23) = "Please excuse me, I have to circuit an AC line through my head to get this database working."
        mstrQuote(24) = "Moving training from your brain to the Bazaar!"
        mstrQuote(25) = "Linux is user friendly..." & vbCrLf & "...it’s just very selective about who its friends are."
        mstrQuote(26) = "A true sign of intelligence is not knowledge but imagination." & vbCrLf & "- Albert Einstein -"
        mstrQuote(27) = "Time flies like an arrow. Fruit flies like a banana." & vbCrLf & "- Tenboro -"
        mstrQuote(28) = "Ceasefire? Why? Ammo's purpose in life is to be used. You're not allowing it to fulfill its destiny. Shame on you!" & vbCrLf & "- Khurn (SotS forum) -"
        mstrQuote(29) = "The road of life twists and turns and no two directions are ever the same. Yet our lessons come from the journey, not the destination." & vbCrLf & "- Don Williams, Jr. -"

        intNum = CInt(30 * Rnd())
        If intNum > 29 Or intNum < 0 Then
            intNum = 29
        End If
        lblQuote.Text = mstrQuote(intNum)
    End Sub

    Public Property AllowLeave() As Boolean
        Get
            Return mblnAllowLeave
        End Get
        Set(ByVal value As Boolean)
            mblnAllowLeave = value
        End Set
    End Property

    Public Property Splash() As Boolean
        Get
            Return mblnSplash
        End Get
        Set(ByVal Value As Boolean)
            mblnSplash = Value
        End Set
    End Property

    Private Sub frmSplash_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblVersion.Text = String.Format("Version {0}", My.Application.Info.Version)
        ToolTips.SetToolTip(lblVersion, RELEASENAME & " Release")
        lblProductName.Text = My.Application.Info.Title
        Me.Icon = My.Resources.icon_EHCalc_small

        'Generate Quote
        If mblnRandomQuote Then
            GenerateQuote()
        End If

        'Is it Splash or About Mode?
        If mblnSplash = True Then
            lblCopyright.Visible = True
            lblQuote.Visible = True
            lblLoading.Visible = True
            lblProductName.Visible = True
            lnkSupport.Visible = False
            lnkEH.Visible = False
            lnkKarma.Visible = False
        Else
            lblProductName.Visible = True
            lblCopyright.Visible = True
            lblQuote.Visible = True
            lblLoading.Visible = False
            lnkSupport.Visible = True
            lnkEH.Visible = True
            lnkKarma.Visible = True
        End If
    End Sub

    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick
        'Handle Timer Event
        mblnSplashDone = True
    End Sub

    Private Sub KeyPressed(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        'Close About Box if a key is pressed
        If mblnAllowLeave Then
            Quit()
        End If
    End Sub

    Private Sub frmSplash_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseClick
        If mblnAllowLeave Then
            Quit()
        End If
    End Sub

    Private Sub KeyPressedLabel(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblVersion.Click, lblQuote.Click, lblCopyright.Click, lblProductName.Click, picGirl.Click
        If mblnAllowLeave Then
            Quit()
        End If
    End Sub

    Private Sub Quit()
        'About box has to have a way to exit no?
        If mblnSplash Then
            Timer.Stop()
            mblnSplashDone = True
        Else
            Me.Close()
        End If
    End Sub

    Public Property LoadingMessage() As String
        Get
            Return lblLoading.Text
        End Get
        Set(ByVal Value As String)
            lblLoading.Text = Value
        End Set
    End Property

    Public Property RandomQuote() As Boolean
        Get
            Return mblnRandomQuote
        End Get
        Set(ByVal value As Boolean)
            mblnRandomQuote = value
        End Set
    End Property

    Public Property Quote() As String
        Get
            Return lblQuote.Text
        End Get
        Set(ByVal value As String)
            lblQuote.Text = value
        End Set
    End Property

    ' Handle Link Clicks
    Private Sub clickLink(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
    Handles lnkSupport.LinkClicked, lnkEH.LinkClicked, lnkKarma.LinkClicked
        Dim strLink As String
        Dim newsender As Windows.Forms.Control = CType(sender, Windows.Forms.Control)

        ' Get Link
        strLink = CStr(newsender.Tag)

        ' Do we use the system default web brwoser?
        If My.Settings.customBrowser Then
            Dim p As New ProcessStartInfo
            p.FileName = My.Settings.browserPath
            p.Arguments = strLink
            Process.Start(p)
        Else
            Process.Start(strLink)
        End If
    End Sub
End Class