﻿Public Class frmEXP

    Private Sub Calculate()
        Dim intCur, intDes As Integer
        Dim intCost As UInt64

        ' Go down the list, calculate costs
        intCur = CInt(numPACur.Value)
        intDes = CInt(numPADes.Value)
        ' Must have a valid desired level!
        If intDes <> intCur Then
            If intDes > intCur Then
                intCost = PACost(intCur, intDes, True)
                txtPACost.Text = intCost.ToString("#,#")
            Else
                intCost = PACost(intCur, intDes, False)
                txtPACost.Text = "-" & intCost.ToString("#,#")
            End If
        Else
            txtPACost.Text = "0"
        End If
    End Sub

    Private Sub Clear()
        numPACur.Value = 0
        numPADes.Value = 0
        txtPACost.Text = ""
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Clear()
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub numberChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
    numPACur.ValueChanged, numPADes.ValueChanged
        Calculate()
    End Sub

    Private Sub numberHighlight(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
    numPACur.Enter, numPADes.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 4)
    End Sub

    ' This function calculates the total EXP needed or returned to get a Primary Attribute from lvl x to y
    ' -Parameters-
    '  intCur (int): Current Primary Attribute Level
    '  intDes (int): Desired Primary Attribute Level
    '  blnUp (Boolean): If true, calculating needed. If False, calculating return
    Private Function PACost(ByVal intCur As Integer, ByVal intDes As Integer, ByVal blnUp As Boolean) As UInt64
        Dim i As Integer = intCur
        Dim total As UInt64 = 0

        If blnUp Then
            Do While i < intDes
                total += CULng(Math.Round(Math.Pow(i + 1, Math.Pow(1.8932743, 1 + (i / 400)))))
                i += 1
            Loop
        Else
            i -= 1
            Do While i > intDes
                total += CULng(Math.Round(Math.Pow(i + 1, Math.Pow(1.8932743, 1 + (i / 400)))))
                i -= 1
            Loop
        End If

        Return total
    End Function
End Class