﻿Public Class frmGPTool
    Private Sub frmGPTool_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Load Icon from the Resources
        Me.Icon = My.Resources.icon_EHCalc_small

        ' Reload our last position
        Me.Location = My.Settings.gpToolPosition

        ' Because the damn Output won't keep it's default display!
        txtOut.Text = "0"
        chkFormat.Checked = My.Settings.formatResults
        cboCreditPerk.SelectedIndex = My.Settings.creditPerk
    End Sub

    Private Sub frmGPTool_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Save Options
        My.Settings.gpToolPosition = Me.Location
        My.Settings.formatResults = chkFormat.Checked

        ' Profile Protected Options
        If Not mblnSaveLock Then
            My.Settings.creditPerk = cboCreditPerk.SelectedIndex
        End If

        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    ' The following monitor the radio buttons and set the display appropriately
    Private Sub rdoBase_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoBase.CheckedChanged
        If rdoBase.Checked = True Then
            txtGPrate.Enabled = False
            lblInput.Text = "Credits (IN)"
            lblOut.Text = "Credits (OUT)"
        Else
            txtGPrate.Enabled = True
        End If
        txtInput.Clear()
        txtOut.Text = "0"
    End Sub

    Private Sub rdoBase2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoBase2.CheckedChanged
        If rdoBase2.Checked = True Then
            txtGPrate.Enabled = False
            lblInput.Text = "Credits (Desired)"
            lblOut.Text = "Credits (Required)"
        Else
            txtGPrate.Enabled = True
        End If
        txtInput.Clear()
        txtOut.Text = "0"
    End Sub

    Private Sub rdoGP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoGP.CheckedChanged
        If rdoGP.Checked Then
            lblInput.Text = "GP"
            lblOut.Text = "Credits"
        End If
        txtInput.Clear()
        txtOut.Text = "0"
    End Sub

    Private Sub rdoCredits_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoCredits.CheckedChanged
        If rdoCredits.Checked Then
            lblInput.Text = "Credits"
            lblOut.Text = "GP"
        End If
        txtInput.Clear()
        txtOut.Text = "0"
    End Sub

    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        ' Variable Decloration
        Dim dblGPrate, dblModifier, dblPerkMod, dblBonusPercent As Double
        Dim intMode, intInput, intResult As Integer

        ' Determin Mode
        If rdoGP.Checked Then
            ' Converting GP to Credits
            intMode = 0
        ElseIf rdoCredits.Checked Then
            ' Determining how many GP to achieve desired Credits
            intMode = 1
        ElseIf rdoBase.Checked Then
            ' Converting Credits before modifier to modifier
            intMode = 2
        ElseIf rdoBase2.Checked Then
            intMode = 3
        Else
            ' Yank out the shotgun
            MsgBox("WTF did you do? SELECT A MODE! Didn't we default one to selected?", MsgBoxStyle.Critical)
            Return
        End If

        ' We got a mode, lets grab some values
        If Not Integer.TryParse(txtInput.Text, intInput) Then
            MsgBox(lblInput.Text & " must be a number!", MsgBoxStyle.Critical)
            Return
        ElseIf (intMode < 2) And Not Double.TryParse(txtGPrate.Text, dblGPrate) Then
            MsgBox("GP Rate must be a positive decimal!", MsgBoxStyle.Critical)
            Return
        ElseIf Not intInput > 0 Then
            MsgBox(lblInput.Text & " must be greater than 0", MsgBoxStyle.Critical)
            Return
        ElseIf intMode < 2 And Not dblGPrate > 0 Then
            MsgBox("GP Rate must be greater than 0", MsgBoxStyle.Critical)
            Return
        End If

        ' What Perk do we have that modifies Credit?
        dblPerkMod = 0
        Select Case (cboCreditPerk.SelectedIndex)
            Case MODE_PENNYPINCHER
                dblPerkMod += CMOD_PENNYPINCHER
            Case MODE_FRUGALITY
                dblPerkMod += CMOD_FRUGALITY
            Case MODE_MASTERMISER
                dblPerkMod += CMOD_MASTERMISER
            Case MODE_STOCKOPTIONS
                dblPerkMod += CMOD_STOCKOPTIONS
            Case MODE_SHORTSELLER
                dblPerkMod += CMOD_SHORTSELLER
            Case MODE_GOLDENHANDSHAKE
                dblPerkMod += CMOD_GOLDENHANDSHAKE
            Case Else
                cboCreditPerk.SelectedIndex = 0
        End Select

        ' Credit Skills
        dblModifier = 1.0 + dblPerkMod
        dblBonusPercent = dblModifier - 1.0

        ' We have our modifier, now do some math!
        Select Case (intMode)
            Case 0
                ' Calculate GP into Credits
                intResult = CInt(Math.Round((intInput / dblGPrate) * dblModifier))
            Case 1
                ' Calculate how much GP to convert to get desired Credits
                ' Round up since Credits can't be split
                intResult = CInt(Math.Round((intInput / dblModifier) * dblGPrate))
            Case 2
                ' Simple Convertion
                intResult = CInt(Math.Round(intInput * dblModifier))
            Case 3
                ' Another Simple Convertion
                intResult = CInt(Math.Round(intInput / dblModifier))
        End Select

        ' Display Result
        If chkFormat.Checked Then
            txtOut.Text = intResult.ToString("#,#")
        Else
            txtOut.Text = intResult.ToString
        End If
        txtBonus.Text = dblBonusPercent.ToString("0.#%")

    End Sub

    Private Sub chkFormat_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFormat.CheckedChanged
        Dim intValue As Integer = CInt(txtOut.Text)

        ' Sanity Check!
        If intValue <= 0 Then
            Return
        End If

        If chkFormat.Checked Then
            txtOut.Text = intValue.ToString("#,#")
        Else
            txtOut.Text = intValue.ToString
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' Close Tool
        Me.Close()
    End Sub
End Class