﻿Public Class frmHVStat
    Const HPTANK As Double = 0.03
    Const MPTANK As Double = 0.03
    Const SPTANK As Double = 0.03
    Const OCTANK As Double = 0.02
    Const SECONDWINDHP As Double = 0.5
    Const SECONDWINDMP As Double = 0.25
    Const SECONDWINDSP As Double = 0.25
    Const SPARKOFLIFESPCOST As Double = 0.5
    Dim SPARKOFLIFEHP() As Double = {0, 0.1, 0.15, 0.2, 0.25, 0.3}
    Const WHITEAURAHP As Double = 0.1
    Const BLACKAURAMP As Double = 0.1

    ' This is the order in which we see Items:
    ' 1. Lesser Potion
    ' 2. Average Potion
    ' 3. Greate Potion
    ' 4. Superior Potion
    ' 5. Godly Potion
    ' 6. Elixer

    ' Item Constants...this will take a while
    ' HP Items
    Dim HPITEMS() As Double = { _
        0.1, _
        0.15, _
        0.2, _
        0.25, _
        0.3, _
        0.3}
    Dim HPITEMSINSTANT() As Double = { _
        0.1, _
        0.4, _
        0.6, _
        0.8, _
        1.0, _
        1.0}
    Dim HPITEMSTURNS() As Integer = { _
        10, _
        10, _
        10, _
        10, _
        10, _
        20}
    ' MP Items
    Dim MPITEMS() As Double = { _
        0.8, _
        0.1, _
        0.13, _
        0.16, _
        0.2, _
        0.2}
    Dim MPITEMSTURNS() As Integer = { _
        5, _
        5, _
        5, _
        5, _
        5, _
        10}
    ' SP Items
    Dim SPITEMS() As Double = { _
        0.8, _
        0.1, _
        0.13, _
        0.16, _
        0.2, _
        0.2}
    Dim SPITEMSTURNS() As Integer = { _
        5, _
        5, _
        5, _
        5, _
        5, _
        10}
    ' GEMS
    Const HPGEM As Double = 1.0
    Const MPGEM As Double = 0.5
    Const SPGEM As Double = 0.25

    ' Following Arrays will contain handles to the labels used to output the item information
    ' used in the loops
    Dim HPITEMLABELS(5) As Label
    Dim MPITEMLABELS(5) As Label
    Dim SPITEMLABELS(5) As Label

    ' Innate Arcana Stuff
    ' 0. Protection
    ' 1. Spark of Life
    ' 2. Haste
    ' 3. Shadow Veil
    ' 4. Spirit Shield
    Dim INNATEARCANABASEMP() As Integer = {25, 50, 30, 30, 25}
    Dim INNATEARCANADURATION() As Integer = {15, 15, 10, 10, 15}
    Dim INNATEARCANAUPKEEPBONUS() As Double = {0, 1, 0.85, 0.7, 0.55, 0.4}
    Dim INNATEARCANACHECKBOXES(4) As CheckBox

    ' Proficiency
    ' 0. Elemental
    ' 1. Divine
    ' 2. Forbidden
    ' 3. Deprecating
    ' 4. Supportive
    ' 5. Curative
    Dim PROFICIENCYINPUT(5) As NumericUpDown
    Dim PROFICIENCYOUTPUT(5) As Label

    ' Global Vars so other Subroutines can read the results
    Dim dblAttackHit, dblAttackCrit, dblAttackRating, dblMagicRating, dblBarrier As Double
    Dim dblHealth, dblMagic, dblSpirit, dblAction, dblMagicHit, dblMagicCrit, dblShield As Double
    Dim dblHealthRegen, dblMagicRegen, dblSpiritRegen, dblOverCharge, dblHPBase, dblMPBase, dblSPBase As Double
    Dim dblHPBattleRegen, dblMPBattleRegen, dblSPBattleRegen, dblProficiency(5), dblInterference As Double
    Dim intInateSkills As Integer
    Dim blnControlsAssigned As Boolean = False

    Private Sub frmHVStat_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Icon = My.Resources.icon_EHCalc_small
        Me.Location = My.Settings.hvStatToolPosition

        LoadHVStats()
    End Sub

    Private Sub frmHVStat_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Save Settings
        My.Settings.hvStatToolPosition = Me.Location

        My.Settings.numPower = numPower.Value
        My.Settings.numSTR = numSTR.Value
        My.Settings.numDEX = numDEX.Value
        My.Settings.numAGI = numAGI.Value
        My.Settings.numEND = numEND.Value
        My.Settings.numINT = numINT.Value
        My.Settings.numWIS = numWIS.Value
        My.Settings.numSTRPlus = numSTRPlus.Value
        My.Settings.numDEXPlus = numDEXPlus.Value
        My.Settings.numAGIPlus = numAGIPlus.Value
        My.Settings.numENDPlus = numENDPlus.Value
        My.Settings.numINTPlus = numINTPlus.Value
        My.Settings.numWISPlus = numWISPlus.Value
        My.Settings.snowflakeSTR = numSnowflakeSTR.Value
        My.Settings.snowflakeDEX = numSnowflakeDEX.Value
        My.Settings.snowflakeAGI = numSnowflakeAGI.Value
        My.Settings.snowflakeEND = numSnowflakeEND.Value
        My.Settings.snowflakeINT = numSnowflakeINT.Value
        My.Settings.snowflakeWIS = numSnowflakeWIS.Value
        My.Settings.evadeChance = numEvade.Value
        My.Settings.shadowVeilAvoid = numShadowVeilAvoidance.Value
        My.Settings.parryChance = numParry.Value
        My.Settings.blockChance = numBlock.Value
        My.Settings.resistChance = numResist.Value
        My.Settings.innateProtectionChk = chkInnateProtection.Checked
        My.Settings.innateSOFChk = chkInnateSOL.Checked
        My.Settings.innateHasteChk = chkInnateHaste.Checked
        My.Settings.innateShadowVeilChk = chkInnateShadowVeil.Checked
        My.Settings.innateArcanaLvl = numInnateAcaneLvl.Value
        My.Settings.innateSpiritShieldChk = chkInnateSpiritShield.Checked
        My.Settings.mobMagicHitChance = numMobHitChanceMagical.Value
        My.Settings.mobAttackHitChance = numMobHitChancePhysical.Value
        My.Settings.interference = numInterference.Value
        My.Settings.elementalProficiency = numElementalProficiency.Value
        My.Settings.divineProficiency = numDivineProficiency.Value
        My.Settings.forbiddenProficiency = numForbiddenProficiency.Value
        My.Settings.deprecatingProficiency = numDeprecatingProficiency.Value
        My.Settings.supportiveProficiency = numSupportiveProficiency.Value
        My.Settings.curativeProficiency = numCurativeProficiency.Value
        My.Settings.onehandedProficiency = numOnehandedProficiency.Value
        My.Settings.twohandedProficiency = numTwohandedProficiency.Value
        My.Settings.dualwieldingProficiency = numDualwieldingProficiency.Value
        My.Settings.staffProficiency = numStaffProficiency.Value
        My.Settings.shieldProficiency = numShieldProficiency.Value
        My.Settings.clothProficiency = numClothProficiency.Value
        My.Settings.lightProficiency = numLightProficiency.Value
        My.Settings.heavyProficiency = numHeavyProficiency.Value

        If Not mblnSaveLock Then ' Profile Protected Stuff
            My.Settings.henjutsuLevel = numLevel.Value
            My.Settings.numAbsorb = numAbsorb.Value
            My.Settings.numSparkofLife = numSparkofLife.Value
            My.Settings.hptank = numHPTank.Value
            My.Settings.mptank = numMPTank.Value
            My.Settings.sptank = numSPTank.Value
            My.Settings.octank = numOCTank.Value
            My.Settings.haste = numHaste.Value
            My.Settings.shadowVeil = numShadowVeil.Value
            My.Settings.spiritShield = numSpiritShield.Value
        End If

        frmMainInstance.Focus()
    End Sub

    Private Sub LoadHVStats()
        ' Grab saved values (if any) and calculate
        numLevel.Value = My.Settings.henjutsuLevel
        numPower.Value = My.Settings.numPower
        numSTR.Value = My.Settings.numSTR
        numDEX.Value = My.Settings.numDEX
        numAGI.Value = My.Settings.numAGI
        numEND.Value = My.Settings.numEND
        numINT.Value = My.Settings.numINT
        numWIS.Value = My.Settings.numWIS
        numSTRPlus.Value = My.Settings.numSTRPlus
        numDEXPlus.Value = My.Settings.numDEXPlus
        numAGIPlus.Value = My.Settings.numAGIPlus
        numENDPlus.Value = My.Settings.numENDPlus
        numINTPlus.Value = My.Settings.numINTPlus
        numWISPlus.Value = My.Settings.numWISPlus
        numSnowflakeSTR.Value = My.Settings.snowflakeSTR
        numSnowflakeDEX.Value = My.Settings.snowflakeDEX
        numSnowflakeAGI.Value = My.Settings.snowflakeAGI
        numSnowflakeEND.Value = My.Settings.snowflakeEND
        numSnowflakeINT.Value = My.Settings.snowflakeINT
        numSnowflakeWIS.Value = My.Settings.snowflakeWIS
        numHPTank.Value = My.Settings.hpTank
        numMPTank.Value = My.Settings.mpTank
        numSPTank.Value = My.Settings.spTank
        numOCTank.Value = My.Settings.octank
        numAbsorb.Value = My.Settings.numAbsorb
        numSparkofLife.Value = My.Settings.numSparkofLife
        numEvade.Value = My.Settings.evadeChance
        numShadowVeilAvoidance.Value = My.Settings.shadowVeilAvoid
        numParry.Value = My.Settings.parryChance
        numBlock.Value = My.Settings.blockChance
        numResist.Value = My.Settings.resistChance
        numInnateAcaneLvl.Value = My.Settings.innateArcanaLvl
        numHaste.Value = My.Settings.haste
        numShadowVeil.Value = My.Settings.shadowVeil
        numSpiritShield.Value = My.Settings.spiritShield
        numMobHitChanceMagical.Value = My.Settings.mobMagicHitChance
        numMobHitChancePhysical.Value = My.Settings.mobAttackHitChance
        numInterference.Value = My.Settings.interference
        numElementalProficiency.Value = My.Settings.elementalProficiency
        numDivineProficiency.Value = My.Settings.divineProficiency
        numForbiddenProficiency.Value = My.Settings.forbiddenProficiency
        numDeprecatingProficiency.Value = My.Settings.deprecatingProficiency
        numSupportiveProficiency.Value = My.Settings.supportiveProficiency
        numCurativeProficiency.Value = My.Settings.curativeProficiency
        numOnehandedProficiency.Value = My.Settings.onehandedProficiency
        numTwohandedProficiency.Value = My.Settings.twohandedProficiency
        numDualwieldingProficiency.Value = My.Settings.dualwieldingProficiency
        numStaffProficiency.Value = My.Settings.staffProficiency
        numShieldProficiency.Value = My.Settings.shieldProficiency
        numClothProficiency.Value = My.Settings.clothProficiency
        numLightProficiency.Value = My.Settings.lightProficiency
        numHeavyProficiency.Value = My.Settings.heavyProficiency

        ' Load these last
        chkInnateProtection.Checked = My.Settings.innateProtectionChk
        chkInnateSOL.Checked = My.Settings.innateSOFChk
        chkInnateHaste.Checked = My.Settings.innateHasteChk
        chkInnateShadowVeil.Checked = My.Settings.innateShadowVeilChk
        chkInnateSpiritShield.Checked = My.Settings.innateSpiritShieldChk

        UpdateStats()
        UpdateAvoidanceStats()
        UpdateProficiencies()
        UpdateFightingChance()
        UpdateInnateArcanaUpkeep()
    End Sub

    Private Sub InitializeControlArrays()
        ' HP Labels
        HPITEMLABELS(0) = lblLesserHPPotion
        HPITEMLABELS(1) = lblAverageHPPotion
        HPITEMLABELS(2) = lblGreaterHPPotion
        HPITEMLABELS(3) = lblSuperiorHPPotion
        HPITEMLABELS(4) = lblGodlyHPPotion
        HPITEMLABELS(5) = lblElixirHP
        ' MP Labels
        MPITEMLABELS(0) = lblLesserMPPotion
        MPITEMLABELS(1) = lblAverageMPPotion
        MPITEMLABELS(2) = lblGreaterMPPotion
        MPITEMLABELS(3) = lblSuperiorMPPotion
        MPITEMLABELS(4) = lblGodlyMPPotion
        MPITEMLABELS(5) = lblElixirMP
        ' SP Labels
        SPITEMLABELS(0) = lblLesserSPPotion
        SPITEMLABELS(1) = lblAverageSPPotion
        SPITEMLABELS(2) = lblGreaterSPPotion
        SPITEMLABELS(3) = lblSuperiorSPPotion
        SPITEMLABELS(4) = lblGodlySPPotion
        SPITEMLABELS(5) = lblElixirSP
        ' Innate Arcana CheckBoxes
        INNATEARCANACHECKBOXES(0) = chkInnateProtection
        INNATEARCANACHECKBOXES(1) = chkInnateSOL
        INNATEARCANACHECKBOXES(2) = chkInnateHaste
        INNATEARCANACHECKBOXES(3) = chkInnateShadowVeil
        INNATEARCANACHECKBOXES(4) = chkInnateSpiritShield
        ' Proficiency
        PROFICIENCYINPUT(0) = numElementalProficiency
        PROFICIENCYINPUT(1) = numDivineProficiency
        PROFICIENCYINPUT(2) = numForbiddenProficiency
        PROFICIENCYINPUT(3) = numDeprecatingProficiency
        PROFICIENCYINPUT(4) = numSupportiveProficiency
        PROFICIENCYINPUT(5) = numCurativeProficiency
        PROFICIENCYOUTPUT(0) = lblElementalProficiencyAdjusted
        PROFICIENCYOUTPUT(1) = lblDivineProficiencyAdjusted
        PROFICIENCYOUTPUT(2) = lblForbiddenProficiencyAdjusted
        PROFICIENCYOUTPUT(3) = lblDeprecatingProficiencyAdjusted
        PROFICIENCYOUTPUT(4) = lblSupportiveProficiencyAdjusted
        PROFICIENCYOUTPUT(5) = lblCurativeProficiencyAdjusted

        blnControlsAssigned = True
    End Sub

    ' Update Fighting Style chances based on Weapon/Armor Proficiency
    Private Sub UpdateFightingChance()
        Dim dblOneHanded, dblTwoHanded, dblDualWielding, dblStaff, dblShield, dblOverwhelmingStrikes, dblCounterAttack, _
        dblDominoStrike, dblOffhandStrike, dblCoalescedMana As Double
        Dim intSTR, intDEX, intAGI, intEND, intINT, intWIS As Integer

        intSTR = CInt(numSTR.Value + numSTRPlus.Value + numSnowflakeSTR.Value)
        intDEX = CInt(numDEX.Value + numDEXPlus.Value + numSnowflakeDEX.Value)
        intAGI = CInt(numAGI.Value + numAGIPlus.Value + numSnowflakeAGI.Value)
        intEND = CInt(numEND.Value + numENDPlus.Value + numSnowflakeEND.Value)
        intINT = CInt(numINT.Value + numINTPlus.Value + numSnowflakeINT.Value)
        intWIS = CInt(numWIS.Value + numWISPlus.Value + numSnowflakeWIS.Value)

        dblOneHanded = CDbl(numOnehandedProficiency.Value)
        dblTwoHanded = CDbl(numTwohandedProficiency.Value)
        dblDualWielding = CDbl(numDualwieldingProficiency.Value)
        dblStaff = CDbl(numStaffProficiency.Value)
        dblShield = CDbl(numShieldProficiency.Value)

        ' Overwhelming Strikes
        dblOverwhelmingStrikes = 5 + (0.02 * intSTR + 0.02 * intEND) * (1 + dblOneHanded / 200)
        If dblOverwhelmingStrikes > 25.0 Then
            dblOverwhelmingStrikes = 25.0
        End If

        ' Counter Attack
        dblCounterAttack = 10 + (0.04 * intSTR + 0.04 * intDEX) * (1 + dblShield / 200)
        If dblCounterAttack > 50.0 Then
            dblOverwhelmingStrikes = 50.0
        End If

        ' Domino Strike
        dblDominoStrike = 40 + (0.04 * intSTR + 0.02 * intDEX) * (1 + dblTwoHanded / 200)
        If dblDominoStrike > 80.0 Then
            dblDominoStrike = 80.0
        End If

        ' Offhand Strike
        dblOffhandStrike = 20 + (0.04 * intAGI + 0.02 * intDEX) * (1 + dblDualWielding / 200)
        If dblOffhandStrike > 50.0 Then
            dblOffhandStrike = 50.0
        End If

        ' Coalesced Mana
        dblCoalescedMana = 10 + (0.04 * intWIS + 0.02 * intINT) * (1 + dblStaff / 200)
        If dblCoalescedMana > 35.0 Then
            dblCoalescedMana = 25.0
        End If

        lblOverwhelmingStrikesChance.Text = dblOverwhelmingStrikes.ToString("0.00") & "%"
        lblCounterAttackChance.Text = dblCounterAttack.ToString("0.00") & "%"
        lblDominoStrikeChance.Text = dblDominoStrike.ToString("0.00") & "%"
        lblOffhandStrikeChance.Text = dblOffhandStrike.ToString("0.00") & "%"
        lblCoalescedManaChance.Text = dblCoalescedMana.ToString("0.00") & "%"

    End Sub

    Private Sub UpdateStats()
        Dim intLevel, intPower, intSTR, intDEX, intAGI, intEND, intINT, intWIS, intHP, intMP, intSP, intOC As Integer
        Dim dblRegenMultiplier, dblItem, dblItemTotal, dblPercentOfTotal, dblItemInstant As Double
        Dim intItem, intItemInstant As Integer

        ' Grab variables
        intLevel = CInt(numLevel.Value)
        intPower = CInt(numPower.Value)
        intSTR = CInt(numSTR.Value + numSTRPlus.Value + numSnowflakeSTR.Value)
        intDEX = CInt(numDEX.Value + numDEXPlus.Value + numSnowflakeDEX.Value)
        intAGI = CInt(numAGI.Value + numAGIPlus.Value + numSnowflakeAGI.Value)
        intEND = CInt(numEND.Value + numENDPlus.Value + numSnowflakeEND.Value)
        intINT = CInt(numINT.Value + numINTPlus.Value + numSnowflakeINT.Value)
        intWIS = CInt(numWIS.Value + numWISPlus.Value + numSnowflakeWIS.Value)
        intHP = CInt(numHPTank.Value)
        intMP = CInt(numMPTank.Value)
        intSP = CInt(numSPTank.Value)
        intOC = CInt(numOCTank.Value)

        ' Somehow I do NOT think the system will let you have negative attributes!
        If intSTR < 0 Then
            intSTR = 0
        End If
        If intDEX < 0 Then
            intDEX = 0
        End If
        If intAGI < 0 Then
            intAGI = 0
        End If
        If intEND < 0 Then
            intEND = 0
        End If
        If intINT < 0 Then
            intINT = 0
        End If
        If intWIS < 0 Then
            intWIS = 0
        End If

        dblRegenMultiplier = 1.0
        If My.Settings.rainbowAuraChecked Then
            dblRegenMultiplier += 0.5
        End If
        If My.Settings.goldAuraChecked Or My.Settings.triAuraChecked Or My.Settings.quintAuraChecked Or My.Settings.septuaAuraChecked _
        Or My.Settings.catgirlAuraChecked Then
            dblRegenMultiplier += 0.5
        End If

        ' Lets do some math!
        ' Primary Stats Base such as HP
        dblHPBase = 50 + intLevel * 5 + intSTR + intEND * 4
        dblMPBase = 10 + intLevel + intINT * 0.25 + intWIS * 0.75
        dblSPBase = 1 + (intPower / 7) + ((intSTR + intDEX + intAGI + intEND + intINT + intWIS) / 10)

        ' Calculate Full stats
        dblHealth = dblHPBase * (1 + HPTANK * intHP)
        dblMagic = dblMPBase * (1 + MPTANK * intMP)
        dblSpirit = dblSPBase * (1 + SPTANK * intSP)
        dblOverCharge = 100 * (1 + OCTANK * intOC)
        dblAttackHit = 100 - (100 * 0.2 * (1 - intDEX / 10 / 100) * (1 - (intAGI / 20 / 100)))
        dblMagicHit = 100 - (100 * 0.2 * (1 - intWIS / 10 / 100) * (1 - (intINT / 20 / 100)))
        dblAttackCrit = 100 - (100 * 0.95 * (1 - (intDEX / 25 / 100)) * (1 - (intAGI / 50 / 100)))
        dblMagicCrit = 100 - (100 * 0.95 * (1 - (intINT / 25 / 100)) * (1 - (intWIS / 50 / 100)))
        'dblEvade = 5 + intDEX / 20 + intAGI / 10
        'dblResist = 5 + intINT / 20 + intWIS / 10
        dblAttackRating = intSTR * 1.25 + intDEX * 0.75
        dblShield = 100 - (100 * Math.Max(1 - intEND * 0.0007, 0.1) * Math.Max(1 - intSTR * 0.0004, 0.5))
        dblMagicRating = intINT * 1.25 + intWIS * 0.75
        dblBarrier = 100 - (100 * Math.Max(1 - intEND * 0.0007, 0.1) * Math.Max(1 - intWIS * 0.0004, 0.5))
        dblHealthRegen = 20 + (intEND / 5 * dblRegenMultiplier)
        dblMagicRegen = 5 + (intWIS / 25 * dblRegenMultiplier)
        dblSpiritRegen = 1 + ((intSTR + intDEX + intAGI + intEND + intINT + intWIS) / 600 * dblRegenMultiplier)
        dblAction = 100 + intAGI / 3

        If My.Settings.whiteAuraChecked Then
            dblHealth *= (1.0 + WHITEAURAHP)
        End If

        If My.Settings.blackAuraChecked Then
            dblMagic *= (1.0 + BLACKAURAMP)
        End If

        ' Items, Items, who's got the items?
        ' Make sure our labels are infact initialized!
        If Not blnControlsAssigned Then
            InitializeControlArrays()
        End If
        ' HP Items
        For i = 0 To HPITEMS.GetUpperBound(0)
            ' Calculate
            dblItem = dblHPBase * HPITEMS(i)
            dblItemInstant = dblHPBase * HPITEMSINSTANT(i)
            dblItemTotal = dblItem * HPITEMSTURNS(i) + dblItemInstant
            dblPercentOfTotal = dblItemTotal / dblHealth
            intItem = CInt(Math.Ceiling(dblItem))
            intItemInstant = CInt(Math.Ceiling(dblItemInstant))

            ' Display output while we are at it
            HPITEMLABELS(i).Text = CStr(intItemInstant) & " Instant, " & CStr(intItem) & "/turn"
            ToolTips.SetToolTip(HPITEMLABELS(i), dblItemInstant.ToString("0.00") & " instant, " & _
                                dblItem.ToString("0.00") & "/turn" & vbCrLf & "Total: " & _
                                dblItemTotal.ToString("0.00") & " (" & dblPercentOfTotal.ToString("0.00%") _
                                & " of Max HP)")
        Next
        ' MP Items
        For i = 0 To MPITEMS.GetUpperBound(0)
            ' Calculate
            dblItem = dblMPBase * MPITEMS(i)
            dblItemTotal = dblItem * MPITEMSTURNS(i)
            dblPercentOfTotal = dblItemTotal / dblMagic
            intItem = CInt(Math.Ceiling(dblItem))

            ' Display output while we are at it
            MPITEMLABELS(i).Text = CStr(intItem)
            ToolTips.SetToolTip(MPITEMLABELS(i), dblItem.ToString("0.00") & vbCrLf & "Total: " & _
                                dblItemTotal.ToString("0.00") & " (" & dblPercentOfTotal.ToString("0.00%") & " of Max MP)")
        Next
        ' SP Items
        For i = 0 To SPITEMS.GetUpperBound(0)
            ' Calculate
            dblItem = dblSPBase * SPITEMS(i)
            dblItemTotal = dblItem * SPITEMSTURNS(i)
            dblPercentOfTotal = dblItemTotal / dblSpirit
            intItem = CInt(Math.Ceiling(dblItem))

            ' Display output while we are at it
            SPITEMLABELS(i).Text = CStr(intItem)
            ToolTips.SetToolTip(SPITEMLABELS(i), dblItem.ToString("0.00") & vbCrLf & "Total: " & _
                                dblItemTotal.ToString("0.00") & " (" & dblPercentOfTotal.ToString("0.00%") & " of Max SP)")
        Next

        ' Now the GEMS
        dblItem = dblHPBase * HPGEM
        lblGemHP.Text = CStr(Math.Ceiling(dblItem))
        dblItem = dblMPBase * MPGEM
        lblGemMP.Text = CStr(Math.Ceiling(dblItem))
        dblItem = dblSPBase * SPGEM
        lblGemSP.Text = CStr(Math.Ceiling(dblItem))

        ' Wow, are we done? Lets do the output
        lblBaseHP.Text = CStr(Math.Round(dblHPBase, 2))
        lblBaseMP.Text = CStr(Math.Round(dblMPBase, 2))
        lblBaseSP.Text = CStr(Math.Round(dblSPBase, 2))
        lblHealthPoints.Text = CStr(Math.Round(dblHealth, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblHealthPoints, dblHealth.ToString("0.000"))
        lblMagicPoints.Text = CStr(Math.Round(dblMagic, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblMagicPoints, dblMagic.ToString("0.000"))
        lblSpiritPoints.Text = CStr(Math.Round(dblSpirit, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblSpiritPoints, dblSpirit.ToString("0.000"))
        lblOvercharge.Text = dblOverCharge.ToString("0") & "%"
        lblAttackHitChance.Text = CStr(Math.Round(dblAttackHit, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblAttackHitChance, dblAttackHit.ToString("0.000"))
        lblMagicHitChance.Text = CStr(Math.Round(dblMagicHit, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblMagicHitChance, dblMagicHit.ToString("0.000"))
        lblAttackCritChance.Text = CStr(Math.Round(dblAttackCrit, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblAttackCritChance, dblAttackCrit.ToString("0.000"))
        lblMagicCritChance.Text = CStr(Math.Round(dblMagicCrit, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblMagicCritChance, dblMagicCrit.ToString("0.000"))
        lblAttackRating.Text = CStr(Math.Round(dblAttackRating, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblAttackRating, dblAttackRating.ToString("0.000"))
        lblShieldRating.Text = CStr(Math.Round(dblShield, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblShieldRating, dblShield.ToString("0.000"))
        lblMagicRating.Text = CStr(Math.Round(dblMagicRating, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblMagicRating, dblMagicRating.ToString("0.000"))
        lblBarrierRating.Text = CStr(Math.Round(dblBarrier, 2, MidpointRounding.AwayFromZero)) & "%"
        ToolTips.SetToolTip(lblBarrierRating, dblBarrier.ToString("0.000"))
        lblHealthRegen.Text = dblHealthRegen.ToString("0.00")
        lblMagicRegen.Text = dblMagicRegen.ToString("0.00")
        lblSpiritRegen.Text = dblSpiritRegen.ToString("0.00")
        lblActionSpeed.Text = CStr(Math.Round(dblAction, 2, MidpointRounding.AwayFromZero))
        ToolTips.SetToolTip(lblActionSpeed, dblAction.ToString("0.000"))

        ' Update Fun Facts
        UpdateFunFacts()

        ' Fighting Chances use some of this stuff
        UpdateFightingChance()

        ' I think we're done :3

    End Sub

    ' Provide fun facts such as HP/MP/SP Regen time, absorb/life statistics, etc
    Private Sub UpdateFunFacts()
        Dim intAbsorb, intLife, intHours, intMinutes As Integer
        Dim dblAbsorbMultiplierLower, dblAbsorbMultiplierHigher, dblAbsorbLower, dblAbsorbHigher, dblLifeHP, _
        dblLifeSP, dblMinutes As Double
        Dim lngMinutes As Long
        Dim strTime As String

        ' Sanity Check
        If dblHealthRegen = 0 Or dblMagicRegen = 0 Or dblSpiritRegen = 0 Then
            Return ' Do NOT divide by 0!
        End If

        ' HP Regen Time
        dblMinutes = dblHealth / dblHealthRegen
        lngMinutes = CLng(Fix(dblMinutes))
        intHours = CInt(lngMinutes \ 60)
        intMinutes = CInt(Math.Ceiling(dblMinutes - (intHours * 60)))
        strTime = intMinutes.ToString() & "m"
        If intHours > 0 Then
            strTime = intHours.ToString() & "h " & strTime
        End If
        lblHPRegenTime.Text = strTime

        ' MP Regen Time
        dblMinutes = dblMagic / dblMagicRegen
        lngMinutes = CLng(Fix(dblMinutes))
        intHours = CInt(lngMinutes \ 60)
        intMinutes = CInt(Math.Ceiling(dblMinutes - (intHours * 60)))
        strTime = intMinutes.ToString() & "m"
        If intHours > 0 Then
            strTime = intHours.ToString() & "h " & strTime
        End If
        lblMPRegenTime.Text = strTime

        ' SP Regen Time
        dblMinutes = dblSpirit / dblSpiritRegen
        lngMinutes = CLng(Fix(dblMinutes))
        intHours = CInt(lngMinutes \ 60)
        intMinutes = CInt(Math.Ceiling(dblMinutes - (intHours * 60)))
        strTime = intMinutes.ToString() & "m"
        If intHours > 0 Then
            strTime = intHours.ToString() & "h " & strTime
        End If
        lblSPRegenTime.Text = strTime

        ' Absorb
        intAbsorb = CInt(numAbsorb.Value)

        ' Don't bother with math if we don't have any points
        If intAbsorb > 0 Then
            dblAbsorbMultiplierLower = (0.05 * (1 + 0.125 * (intAbsorb - 1)))
            dblAbsorbMultiplierHigher = (0.1 * (1 + 0.125 * (intAbsorb - 1)))
            dblAbsorbLower = dblMPBase * dblAbsorbMultiplierLower
            dblAbsorbHigher = dblMPBase * dblAbsorbMultiplierHigher
            lblAbsorb.Text = CStr(Math.Round(dblAbsorbLower, MidpointRounding.AwayFromZero)) & " - " & _
            CStr(Math.Round(dblAbsorbHigher, MidpointRounding.AwayFromZero)) & " MP"
            ToolTips.SetToolTip(lblAbsorb, dblAbsorbLower.ToString("0.00") & " - " & dblAbsorbHigher.ToString("0.00") & " MP")
        Else
            lblAbsorb.Text = "NA"
            ToolTips.SetToolTip(lblAbsorb, "NA")
        End If

        ' Spark of Life
        intLife = CInt(numSparkofLife.Value)
        If intLife > 0 Then
            If intLife = 1 Then
                dblLifeHP = 1
            Else
                dblLifeHP = dblHealth * SPARKOFLIFEHP(intLife)
            End If
            dblLifeSP = dblSPBase * SPARKOFLIFESPCOST
            lblSparkofLife.Text = CStr(Math.Round(dblLifeHP, MidpointRounding.AwayFromZero)) & " HP for " & _
            CStr(Math.Floor(dblLifeSP) & " SP")
            ToolTips.SetToolTip(lblSparkofLife, dblLifeHP.ToString("0.00") & " HP for " & dblLifeSP.ToString("0.00") & " SP")
        Else
            lblSparkofLife.Text = "NA"
            ToolTips.SetToolTip(lblSparkofLife, "NA")
        End If

        ' In Battle Natural Regen - You gain 2 seconds of natural regen per turn
        ' HP
        'dblHPBattleRegen = dblHealthRegen / 30
        dblHPBattleRegen = 0.0
        lblHPRegenTurn.Text = dblHPBattleRegen.ToString("0.##")
        ' MP
        dblMPBattleRegen = dblMagicRegen / 15
        lblMPRegenTurn.Text = dblMPBattleRegen.ToString("0.##")
        ' SP
        dblSPBattleRegen = dblSpiritRegen / 30
        lblSPRegenTurn.Text = dblSPBattleRegen.ToString("0.##")

        ' Because changing the MP Battle Regen will effect I.A. Actual Upkeep...
        UpdateInnateArcanaUpkeep()

    End Sub

    Private Sub UpdateProficiencies()
        Dim dblPenalty As Double
        If Not blnControlsAssigned Then
            InitializeControlArrays()
        End If

        dblInterference = CDbl(numInterference.Value)

        For i = 0 To 5
            ' System now shows 'effective' proficiencies, no need to calculate
            'If dblInterference > 25.0 Then
            '    dblPenalty = CDbl(PROFICIENCYINPUT(i).Value) * ((dblInterference - 25) * 0.0075)
            '    dblProficiency(i) = CDbl(PROFICIENCYINPUT(i).Value) * (1 - ((dblInterference - 25) * 0.0075))
            '    If dblProficiency(i) < 0 Then ' Can't have negative proficiencies!
            '        dblProficiency(i) = 0
            '        dblPenalty = CDbl(PROFICIENCYINPUT(i).Value)
            '    End If
            'Else
            '    dblProficiency(i) = CDbl(PROFICIENCYINPUT(i).Value)
            '    dblPenalty = 0.0
            'End If
            dblProficiency(i) = CDbl(PROFICIENCYINPUT(i).Value)
            dblPenalty = 0
            PROFICIENCYOUTPUT(i).Text = dblProficiency(i).ToString("0.00")
            ToolTips.SetToolTip(PROFICIENCYOUTPUT(i), "-" & dblPenalty.ToString("0.00"))
        Next

    End Sub

    ' Calculates the overall avoidance you get with your armor. This does NOT include enemy hit chance!
    Private Sub UpdateAvoidanceStats()
        Dim dblMobAttackHitChance, dblMobMagicHitChance, dblEvade, dblParry, dblBlock, dblResist, dblTotalPhysical, _
        dblTotalPhysicalWithShadow, dblTotalMagical As Double

        dblMobAttackHitChance = (CDbl(numMobHitChancePhysical.Value) / 100)
        dblMobMagicHitChance = (CDbl(numMobHitChanceMagical.Value) / 100)
        ' For statistic reasons, cap Attack Hit Chance at 100!
        If dblMobAttackHitChance > 100 Then
            dblMobAttackHitChance = 100.0
        End If
        If dblMobMagicHitChance > 100 Then
            dblMobMagicHitChance = 100.0
        End If
        dblEvade = 1 - CDbl(numEvade.Value) / 100
        dblParry = 1 - CDbl(numParry.Value) / 100
        dblBlock = 1 - CDbl(numBlock.Value) / 100
        dblResist = 1 - CDbl(numResist.Value) / 100

        ' Chances to avoid a physical hit/skill
        dblTotalPhysical = 100 - (100 * dblMobAttackHitChance * dblEvade * dblParry * dblBlock)
        ' Chance to avoid a physical hit/skill while Shadow Viel is Active
        dblTotalPhysicalWithShadow = 100 - (100 * (dblMobAttackHitChance - (numShadowVeilAvoidance.Value / 100)) * dblEvade * dblParry * dblBlock)
        ' Chances to avoid a magic spell (I've evaded spells such as mEH)
        dblTotalMagical = 100 - (100 * dblMobMagicHitChance * dblEvade * dblBlock * dblResist)

        lblAvoidancePhysical.Text = dblTotalPhysical.ToString("0.00") & "%"
        lblAvoidancePhysicalWithShadow.Text = dblTotalPhysicalWithShadow.ToString("0.00") & "%"
        lblAvoidanceMagical.Text = dblTotalMagical.ToString("0.00") & "%"
    End Sub

    ' Calculates the Innate Arcana Upkeep Costs
    Private Sub UpdateInnateArcanaUpkeep()
        Dim intInnateArcanaLvl, intLevel As Integer
        Dim dblMPCost, dblDuration, dblUpkeepCost, dblUpkeepCostAdjusted, dblMPRegenAdjusted As Double
        ' Ability Point Array
        Dim intAbilityPoints(4) As Integer
        intAbilityPoints(0) = 0
        ' In case they say they have an auto-cast of Haste/SV, assume 1 point has been put into it
        If numSparkofLife.Value < 1 Then
            intAbilityPoints(1) = -1
        Else
            intAbilityPoints(1) = CInt(numSparkofLife.Value) - 1
        End If
        If numHaste.Value < 1 Then
            intAbilityPoints(2) = -1
        Else
            intAbilityPoints(2) = CInt(numHaste.Value) - 1
        End If
        If numShadowVeil.Value < 1 Then
            intAbilityPoints(3) = -1
        Else
            intAbilityPoints(3) = CInt(numShadowVeil.Value) - 1
        End If
        If numSpiritShield.Value < 1 Then
            intAbilityPoints(4) = -1
        Else
            intAbilityPoints(4) = CInt(numSpiritShield.Value) - 1
        End If

        ' Have we initlized the control arrays?
        If Not blnControlsAssigned Then
            InitializeControlArrays()
        End If

        intInnateArcanaLvl = CInt(numInnateAcaneLvl.Value)
        intLevel = CInt(numLevel.Value)

        If intInnateArcanaLvl < 1 Then
            lblInnateUpkeep.Text = "N/A"
            lblInnateUpkeepActual.Text = "N/A"
            lblMPRegenTurnActual.Text = "N/A"
            Exit Sub ' No point continuing Is there?
        End If

        dblUpkeepCost = 0

        ' Start Loop
        For i = 0 To 4
            If INNATEARCANACHECKBOXES(i).Checked Then
                dblMPCost = Math.Ceiling(intLevel * (INNATEARCANABASEMP(i) / 100))
                dblDuration = INNATEARCANADURATION(i) * (1 + intAbilityPoints(i) * 0.25) * (1 + dblProficiency(4) / 100)
                If intAbilityPoints(i) < 0 Then
                    dblUpkeepCost += 0.0
                Else
                    dblUpkeepCost += dblMPCost / dblDuration
                End If
            End If
        Next

        ' Apply Upkeep Cost Reduction last
        dblUpkeepCost *= INNATEARCANAUPKEEPBONUS(intInnateArcanaLvl)
        dblUpkeepCostAdjusted = dblUpkeepCost - dblMPBattleRegen
        dblMPRegenAdjusted = dblMPBattleRegen - dblUpkeepCost

        If dblUpkeepCostAdjusted < 0 Then
            dblUpkeepCostAdjusted = 0.0
        End If

        ' Display Output
        lblInnateUpkeep.Text = dblUpkeepCost.ToString("0.00") & " MP/turn"
        lblInnateUpkeepActual.Text = dblUpkeepCostAdjusted.ToString("0.00") & " MP/turn"
        lblMPRegenTurnActual.Text = dblMPRegenAdjusted.ToString("0.00")
    End Sub

    ' Lazy people...
    Private Sub CalculateShadowVeil()
        Dim dblShadowVeilAvoidance As Double
        Dim intShadowVeilPoints As Integer = CInt(numShadowVeil.Value)

        ' The base evade boost is 5%
        ' Every ten points of proficiency increases the bonus by 1%
        If intShadowVeilPoints > 0 Then
            dblShadowVeilAvoidance = 5 + (dblProficiency(4) / 10)
            If dblShadowVeilAvoidance > 100 Then
                dblShadowVeilAvoidance = 100.0
            End If
            numShadowVeilAvoidance.Value = CDec(dblShadowVeilAvoidance)
        Else
            numShadowVeilAvoidance.Value = CDec(0.0)
        End If
    End Sub

    ' Calculates how much Regen I and II gives you each turn and for how long
    ' And no Boggyb, I will not put in a check to see if you HAVE Regen I or II
    Private Sub CalculateRegen()
        Dim dblRegenIRate, dblRegenIIRate, dblRegenITotal, dblRegenIITotal As Double
        Dim intRegenIDuration, intRegenIIDuration As Integer

        ' Sayo's equation:
        ' Amount of HP restored per turn = base HP * 3 * (1 + prof / 100 + (prof / 200) ^ 2) / 100 , rounded up.
        'dblRegenIRate = Math.Ceiling(dblHPBase * 3.0 * (1 + dblProficiency(5) / 100 + Math.Pow(dblProficiency(5) / 200, 2)) / 100)
        'dblRegenIIRate = Math.Ceiling(dblHPBase * 3.6 * (1 + dblProficiency(5) / 100 + Math.Pow(dblProficiency(5) / 200, 2)) / 100)
        dblRegenIRate = Math.Ceiling(dblHPBase * ((4.5 * (1 + dblProficiency(5) / 100)) / 100))
        dblRegenIIRate = Math.Ceiling(dblHPBase * ((6.0 * (1 + dblProficiency(5) / 100)) / 100))
        ' I'm taking a guess with duration
        intRegenIDuration = CInt(Math.Round(10 * (1 + dblProficiency(5) / 100), 0, MidpointRounding.AwayFromZero))
        intRegenIIDuration = CInt(Math.Round(25 * (1 + dblProficiency(5) / 100), 0, MidpointRounding.AwayFromZero))
        dblRegenITotal = dblRegenIRate * intRegenIDuration
        dblRegenIITotal = dblRegenIIRate * intRegenIIDuration

        lblRegenI.Text = dblRegenIRate.ToString("0") & " HP/turn"
        ToolTips.SetToolTip(lblRegenI, dblRegenITotal.ToString("#,0") & " HP over " & intRegenIDuration.ToString() & " turns")
        lblRegenII.Text = dblRegenIIRate.ToString("0") & " HP/turn"
        ToolTips.SetToolTip(lblRegenII, dblRegenIITotal.ToString("#,0") & " HP over " & intRegenIIDuration.ToString() & " turns")
    End Sub

    ' Clear Values
    Private Sub Clear()
        ' Clear Inputs
        numLevel.Value = 0
        numPower.Value = 1
        numSTR.Value = 0
        numDEX.Value = 0
        numAGI.Value = 0
        numEND.Value = 0
        numINT.Value = 0
        numWIS.Value = 0
        numSTRPlus.Value = 0
        numDEXPlus.Value = 0
        numAGIPlus.Value = 0
        numENDPlus.Value = 0
        numINTPlus.Value = 0
        numWISPlus.Value = 0
        numHPTank.Value = 0
        numMPTank.Value = 0
        numSPTank.Value = 0
        numOCTank.Value = 0
        numEvade.Value = 0
        numParry.Value = 0
        numBlock.Value = 0
        numResist.Value = 0
        numInterference.Value = 0
        numMobHitChanceMagical.Value = 75
        numMobHitChancePhysical.Value = 75
        numInnateAcaneLvl.Value = 0
        numSnowflakeAGI.Value = 0
        numSnowflakeDEX.Value = 0
        numSnowflakeEND.Value = 0
        numSnowflakeINT.Value = 0
        numSnowflakeSTR.Value = 0
        numSnowflakeWIS.Value = 0
        numElementalProficiency.Value = 0
        numDivineProficiency.Value = 0
        numForbiddenProficiency.Value = 0
        numDeprecatingProficiency.Value = 0
        numSupportiveProficiency.Value = 0
        numCurativeProficiency.Value = 0
        numOnehandedProficiency.Value = 0
        numTwohandedProficiency.Value = 0
        numDualwieldingProficiency.Value = 0
        numStaffProficiency.Value = 0
        numShieldProficiency.Value = 0
        numClothProficiency.Value = 0
        numLightProficiency.Value = 0
        numHeavyProficiency.Value = 0

        ' Clear Outputs
        lblBaseHP.Text = "0.00"
        lblBaseMP.Text = "0.00"
        lblBaseSP.Text = "0.00"
        lblHealthPoints.Text = "0.00"
        ToolTips.SetToolTip(lblHealthPoints, "0.00")
        lblMagicPoints.Text = "0.00"
        ToolTips.SetToolTip(lblMagicPoints, "0.00")
        lblSpiritPoints.Text = "0.00"
        ToolTips.SetToolTip(lblSpiritPoints, "0.00")
        lblOvercharge.Text = "0"
        lblAttackHitChance.Text = "0.00"
        ToolTips.SetToolTip(lblAttackHitChance, "0.00")
        lblMagicHitChance.Text = "0.00"
        ToolTips.SetToolTip(lblMagicHitChance, "0.00")
        lblAttackCritChance.Text = "0.00"
        ToolTips.SetToolTip(lblAttackCritChance, "0.00")
        lblMagicCritChance.Text = "0.00"
        ToolTips.SetToolTip(lblMagicCritChance, "0.00")
        'lblEvadeChance.Text = "0.00"
        'ToolTips.SetToolTip(lblEvadeChance, "0.00")
        'lblResistChance.Text = "0.00"
        'ToolTips.SetToolTip(lblResistChance, "0.00")
        lblAttackRating.Text = "0.00"
        ToolTips.SetToolTip(lblAttackRating, "0.00")
        lblShieldRating.Text = "0.00"
        ToolTips.SetToolTip(lblShieldRating, "0.00")
        lblMagicRating.Text = "0.00"
        ToolTips.SetToolTip(lblMagicRating, "0.00")
        lblBarrierRating.Text = "0.00"
        ToolTips.SetToolTip(lblBarrierRating, "0.00")
        lblHealthRegen.Text = "0.00"
        lblMagicRegen.Text = "0.00"
        lblSpiritRegen.Text = "0.00"
        lblActionSpeed.Text = "0.00"
        ToolTips.SetToolTip(lblActionSpeed, "0.00")

        ' Items
        ' Make sure we are initialized!
        If Not blnControlsAssigned Then
            InitializeControlArrays()
        End If
        ' HP Items
        For i = 0 To HPITEMS.GetUpperBound(0)
            HPITEMLABELS(i).Text = "0"
            ToolTips.SetToolTip(HPITEMLABELS(i), "0.00")
        Next
        ' MP Items
        For i = 0 To MPITEMS.GetUpperBound(0)
            MPITEMLABELS(i).Text = "0"
            ToolTips.SetToolTip(MPITEMLABELS(i), "0.00")
        Next
        ' SP Items
        For i = 0 To SPITEMS.GetUpperBound(0)
            SPITEMLABELS(i).Text = "0"
            ToolTips.SetToolTip(SPITEMLABELS(i), "0.00")
        Next
        ' Proficiencies
        For i = 0 To 5
            dblProficiency(i) = 0.0
            PROFICIENCYOUTPUT(i).Text = "N/A"
            ToolTips.SetToolTip(PROFICIENCYOUTPUT(i), "")
        Next

        lblHPRegenTime.Text = "NA"
        ToolTips.SetToolTip(lblHPRegenTime, "NA")
        lblMPRegenTime.Text = "NA"
        ToolTips.SetToolTip(lblMPRegenTime, "NA")
        lblSPRegenTime.Text = "NA"
        ToolTips.SetToolTip(lblSPRegenTime, "NA")
        lblAbsorb.Text = "NA"
        ToolTips.SetToolTip(lblAbsorb, "NA")
        lblSparkofLife.Text = "NA"
        ToolTips.SetToolTip(lblSparkofLife, "NA")
        lblAvoidancePhysical.Text = "NA"
        lblAvoidancePhysicalWithShadow.Text = "NA"
        lblAvoidanceMagical.Text = "NA"
        lblInnateUpkeep.Text = "NA"
        lblInnateUpkeepActual.Text = "NA"
        lblRegenI.Text = "NA"
        ToolTips.SetToolTip(lblRegenI, "NA")
        lblRegenII.Text = "NA"
        ToolTips.SetToolTip(lblRegenII, "NA")
        lblOverwhelmingStrikesChance.Text = "NA"
        lblCounterAttackChance.Text = "NA"
        lblDominoStrikeChance.Text = "NA"
        lblOffhandStrikeChance.Text = "NA"
        lblCoalescedManaChance.Text = "NA"
    End Sub

    ' Caluclate Stats
    Private Sub PrimaryAttributeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAGI.ValueChanged, numDEX.ValueChanged, numEND.ValueChanged, numHPTank.ValueChanged, _
    numINT.ValueChanged, numLevel.ValueChanged, numMPTank.ValueChanged, numOCTank.ValueChanged, numPower.ValueChanged, numSPTank.ValueChanged, numSTR.ValueChanged, numWIS.ValueChanged, _
    numSTRPlus.ValueChanged, numDEXPlus.ValueChanged, numAGIPlus.ValueChanged, numENDPlus.ValueChanged, numINTPlus.ValueChanged, numWISPlus.ValueChanged, numSnowflakeAGI.ValueChanged, _
    numSnowflakeDEX.ValueChanged, numSnowflakeEND.ValueChanged, numSnowflakeINT.ValueChanged, numSnowflakeSTR.ValueChanged, numSnowflakeWIS.ValueChanged
        UpdateStats()
    End Sub

    Private Sub SelectPrimaryAttribute(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAGI.Enter, numDEX.Enter, numEND.Enter, numHPTank.Enter, _
    numINT.Enter, numLevel.Enter, numMPTank.Enter, numOCTank.Enter, numPower.Enter, numSPTank.Enter, numSTR.Enter, numWIS.Enter, numSTRPlus.Enter, numDEXPlus.Enter, numAGIPlus.Enter, _
    numENDPlus.Enter, numINTPlus.Enter, numWISPlus.Enter, numEvade.Enter, numParry.Enter, numBlock.Enter, numResist.Enter, _
     numShadowVeilAvoidance.Enter, numSnowflakeAGI.Enter, numSnowflakeDEX.Enter, numSnowflakeEND.Enter, _
    numSnowflakeINT.Enter, numSnowflakeSTR.Enter, numSnowflakeWIS.Enter, numInnateAcaneLvl.Enter, numSparkofLife.Enter, numAbsorb.Enter, numHaste.Enter, numShadowVeil.Enter, _
    numElementalProficiency.Enter, numDivineProficiency.Enter, numForbiddenProficiency.Enter, numDeprecatingProficiency.Enter, numSupportiveProficiency.Enter, _
    numCurativeProficiency.Enter, numInterference.Enter, numMobHitChanceMagical.Enter, numMobHitChancePhysical.Enter, numOnehandedProficiency.Enter, numTwohandedProficiency.Enter, _
    numDualwieldingProficiency.Enter, numStaffProficiency.Enter, numShieldProficiency.Enter, numClothProficiency.Enter, numLightProficiency.Enter, numHeavyProficiency.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 10)
    End Sub

    Private Sub numAvoidance_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numEvade.ValueChanged, _
    numParry.ValueChanged, numBlock.ValueChanged, numResist.ValueChanged, numShadowVeilAvoidance.ValueChanged, numMobHitChanceMagical.ValueChanged, _
    numMobHitChancePhysical.ValueChanged
        UpdateAvoidanceStats()
    End Sub

    Private Sub btnProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProfile.Click
        Dim frmMyProfile As New frmProfile
        ' Unlike other Dialogs, we do not want other stuff going on while this is open!
        frmMyProfile.ShowDialog()
        frmMyProfile = Nothing
        UpdateStats()
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        ' Call the clear function
        Clear()
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' Do I need to explain this?
        Me.Close()
    End Sub

    Private Sub numFunFacts_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAbsorb.ValueChanged, numSparkofLife.ValueChanged
        UpdateFunFacts()
    End Sub

    Private Sub chkInnate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInnateProtection.CheckedChanged, _
    chkInnateSOL.CheckedChanged, chkInnateHaste.CheckedChanged, chkInnateShadowVeil.CheckedChanged, chkInnateSpiritShield.CheckedChanged
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        If newSender.Checked Then
            intInateSkills += 1
        Else
            intInateSkills -= 1
        End If

        ' If you select 3 skills when you only have lvl 2, de-select
        If intInateSkills > numInnateAcaneLvl.Value Then
            newSender.Checked = False
        Else
            UpdateInnateArcanaUpkeep()
        End If
    End Sub

    Private Sub numInnateArcanaLvl_ValueChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numInnateAcaneLvl.ValueChanged
        If intInateSkills > numInnateAcaneLvl.Value Then
            ' Make sure our labels are infact initialized!
            If Not blnControlsAssigned Then
                InitializeControlArrays()
            End If
            Dim i As Integer = 4
            While intInateSkills > numInnateAcaneLvl.Value
                If i < 0 Then
                    Exit While
                End If
                INNATEARCANACHECKBOXES(i).Checked = False
                i -= 1
            End While
        End If
        UpdateInnateArcanaUpkeep()
    End Sub

    Private Sub numHaste_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numHaste.ValueChanged
        UpdateInnateArcanaUpkeep()
    End Sub

    Private Sub shadowVeilChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numShadowVeil.ValueChanged
        CalculateShadowVeil()
        UpdateInnateArcanaUpkeep()
    End Sub

    Private Sub MagicProficiency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numElementalProficiency.ValueChanged, _
    numDivineProficiency.ValueChanged, numForbiddenProficiency.ValueChanged, numDeprecatingProficiency.ValueChanged, numSupportiveProficiency.ValueChanged, _
    numCurativeProficiency.ValueChanged, numInterference.ValueChanged
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        UpdateProficiencies()
        If newSender Is numSupportiveProficiency Then
            CalculateShadowVeil()
        End If
        If newSender Is numCurativeProficiency Then
            CalculateRegen()
        End If
        UpdateInnateArcanaUpkeep()
    End Sub

    Private Sub EquipmentProFiciency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numOnehandedProficiency.ValueChanged, _
    numTwohandedProficiency.ValueChanged, numDualwieldingProficiency.ValueChanged, numStaffProficiency.ValueChanged, numShieldProficiency.ValueChanged, _
    numClothProficiency.ValueChanged, numLightProficiency.ValueChanged, numHeavyProficiency.ValueChanged
        UpdateFightingChance()
    End Sub


    ' Multiplicative Calculator
    Private Sub btnMultiplicativeCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMultiplicativeCalc.Click
        Dim frmMultiplicative As New frmMultiplicativeCalc
        frmMultiplicative.Show()
    End Sub
End Class
