﻿' EH Calculator v3
' Copyright (c) 2009-2011, Cursix Computing
' All rights reserved.
' See README for more information including license details.

Imports System.Threading

Module mMain
    ' Constants
    ' Release Name
    Public Const RELEASENAME As String = "Belkin"

    ' EXP Modifiers
    Public Const EXPMOD_REDAURA As Double = 0.07
    Public Const EXPMOD_ORANGEAURA As Double = 0.07
    Public Const EXPMOD_YELLOWAURA As Double = 0.07
    Public Const EXPMOD_GREENAURA As Double = 0.07
    Public Const EXPMOD_BLUEAURA As Double = 0.07
    Public Const EXPMOD_INDIGOAURA As Double = 0.07
    Public Const EXPMOD_VIOLETAURA As Double = 0.07
    Public Const EXPMOD_BLACKAURA As Double = 0.5
    Public Const EXPMOD_WHITEAURA As Double = 0.5
    Public Const EXPMOD_RAINBOWAURA As Double = 0.77
    Public Const EXPMOD_BRONZEAURA As Double = 0.25
    Public Const EXPMOD_SILVERAURA As Double = 0.5
    Public Const EXPMOD_GOLDAURA As Double = 1.0
    Public Const EXPMOD_TRIAURA As Double = 1.5
    Public Const EXPMOD_QUINTAURA As Double = 2.0
    Public Const EXPMOD_SEPTUAAURA As Double = 2.5
    Public Const EXPMOD_CATGIRLAURA As Double = 3.0
    Public Const EXPMOD_POWERTANK As Double = 0.05
    Public Const EXPMOD_EXPSKILL As Double = 0.03
    Public Const EXPMOD_ADEPTLEARNER As Double = 0.01
    Public Const EXPMOD_ORGANIZEDMIND As Double = 0.1
    Public Const EXPMOD_DISCIPLINEDLEARNER As Double = 0.2
    Public Const EXPMOD_THINKINGCAP As Double = 0.35
    Public Const EXPMOD_MENTATS As Double = 0.5
    Public Const EXPMOD_LEARNINGCHIP As Double = 0.75
    Public Const EXPMOD_CYBERNETICBRAIN As Double = 1.0
    Public Const EXPMOD_COOKIE As Double = 0.2
    Public Const EXPMOD_TWIN As Double = 1.0
    Public Const EXPMOD_DULL As Double = 0.5
    Public Const EXPMOD_GOLDENAT As Double = 0.25
    Public Const EXPMOD_YELLOWCRYSTAL As Double = 1.0
    Public Const EXPMOD_BLUECRYSTAL As Double = 0.75
    Public Const EXPMOD_PURPLECRYSTAL As Double = 0.5
    Public Const EXPMOD_SNOWFLAKEHAND As Double = 1.0
    Public Const EXPMOD_SNOWFLAKEPRIDE As Double = 0.75
    Public Const EXPMOD_SNOWFLAKEESTEEM As Double = 0.5

    ' Credit Modifiers
    Public Const CMOD_PENNYPINCHER As Double = 0.01
    Public Const CMOD_FRUGALITY As Double = 0.02
    Public Const CMOD_MASTERMISER As Double = 0.04
    Public Const CMOD_STOCKOPTIONS As Double = 0.06
    Public Const CMOD_SHORTSELLER As Double = 0.08
    Public Const CMOD_GOLDENHANDSHAKE As Double = 0.1

    ' Power Modifiers
    Public Const PMOD_REDAURA As Double = 0.07
    Public Const PMOD_ORANGEAURA As Double = 0.07
    Public Const PMOD_YELLOWAURA As Double = 0.07
    Public Const PMOD_GREENAURA As Double = 0.07
    Public Const PMOD_BLUEAURA As Double = 0.07
    Public Const PMOD_INDIGOAURA As Double = 0.07
    Public Const PMOD_VIOLETAURA As Double = 0.07
    Public Const PMOD_BLACKAURA As Double = 0.25
    Public Const PMOD_WHITEAURA As Double = 0.25
    Public Const PMOD_RAINBOWAURA As Double = 0.77
    Public Const PMOD_BRONZEAURA As Double = 0.25
    Public Const PMOD_SILVERAURA As Double = 0.5
    Public Const PMOD_GOLDAURA As Double = 1.0
    Public Const PMOD_TRIAURA As Double = 1.5
    Public Const PMOD_QUINTAURA As Double = 2.0
    Public Const PMOD_SEPTUAAURA As Double = 2.5
    Public Const PMOD_CATGIRLAURA As Double = 3.0
    Public Const PMOD_COOKIE As Double = 0.2
    Public Const PMOD_TWIN As Double = 1.0
    Public Const PMOD_DULL As Double = 0.5
    Public Const PMOD_YELLOWCRYSTAL As Double = 1.0
    Public Const PMOD_BLUECRYSTAL As Double = 0.75
    Public Const PMOD_PURPLECRYSTAL As Double = 0.5
    Public Const PMOD_SNOWFLAKEHAND As Double = 0.0
    Public Const PMOD_SNOWFLAKEPRIDE As Double = 0.0
    Public Const PMOD_SNOWFLAKEESTEEM As Double = 0.0

    ' Dawn of a New Day
    Public Const DAWN_NONE As Double = 5.0
    Public Const DAWN_BRONZE As Double = 200.0
    Public Const DAWN_SILVER As Double = 500.0
    Public Const DAWN_GOLD As Double = 1000.0
    Public Const DAWN_TRI As Double = 2000.0
    Public Const DAWN_QUINT As Double = 5000.0
    Public Const DAWN_SEPTUA As Double = 8000.0
    Public Const DAWN_CATGIRL As Double = 10000.0
    Public Const DAWN_DULL As Double = 100.0
    Public Const DAWN_TWIN As Double = 200.0
    Public Const DAWN_COOKIE As Double = 0.0
    Public Const DAWN_YELLOWCRYSTAL As Double = 500.0
    Public Const DAWN_BLUECRYSTAL As Double = 250.0
    Public Const DAWN_PURPLECRYSTAL As Double = 100.0
    Public Const DAWN_SNOWFLAKEHAND As Double = 500.0
    Public Const DAWN_SNOWFLAKEPRIDE As Double = 250.0
    Public Const DAWN_SNOWFLAKEESTEEM As Double = 100.0

    ' Define Credit Perks
    Public Const MODE_PENNYPINCHER As Integer = 1
    Public Const MODE_FRUGALITY As Integer = 2
    Public Const MODE_MASTERMISER As Integer = 3
    Public Const MODE_STOCKOPTIONS As Integer = 4
    Public Const MODE_SHORTSELLER As Integer = 5
    Public Const MODE_GOLDENHANDSHAKE As Integer = 6

    ' Define Exp Perks
    Public Const MODE_ORGANIZEDMIND As Integer = 1
    Public Const MODE_DISCIPLINEDLEARNER As Integer = 2
    Public Const MODE_THINKINGCAP As Integer = 3
    Public Const MODE_MENTATS As Integer = 4
    Public Const MODE_LEARNINGCHIP As Integer = 5
    Public Const MODE_CYBERNETICBRAIN As Integer = 6

    ' Define Legendary perks
    Public Const MODE_DEMON As Integer = 1
    Public Const MODE_GRACE As Integer = 2
    Public Const MODE_DUST As Integer = 3
    Public Const MODE_KNOWLEDGE As Integer = 4
    Public Const MODE_COMPASSES As Integer = 5
    Public Const MODE_PARADISELOST As Integer = 6

    ' HV Timer
    Public Const BROWSERLAUNCH As Integer = 0
    Public Const NOTIFYLAUNCH As Integer = 1

    ' Misc Post Additions
    Public Const MISCPOST_BASE As Double = 5.0
    Public Const MISCPOST_DAY As Double = 0.125
    Public Const MISCPOST_TRAINING As Double = 25.0
    Public Const MISCPOST_BRONZE As Double = 25.0
    Public Const MISCPOST_SILVER As Double = 50.0
    Public Const MISCPOST_GOLD As Double = 100.0
    Public Const MISCPOST_TRI As Double = 200.0
    Public Const MISCPOST_QUINT As Double = 300.0
    Public Const MISCPOST_SEPTUA As Double = 400.0
    Public Const MISCPOST_CATGIRL As Double = 500.0

    ' Define EXP Bonus for Toplists
    Public EXP_TOPLIST() As Double = {0, 0.5, 0.4, 0.35, 0.3, 0.25, 0.2, 0.19, 0.18, 0.17, 0.16, _
    0.15, 0.14, 0.13, 0.12, 0.11, 0.1, 0.09, 0.08, 0.07, 0.06, 0.05, 0.04, 0.03, 0.02, 0.01}

    ' Splash stuff
    Public mblnSplashDone As Boolean
    ' Save Settings
    Public mblnSaveSettings As Boolean
    Public mblnSaveLock As Boolean
    Public mblnResetSettings As Boolean = False
    ' The Main Form
    Public frmMainInstance As frmMain

    ' This call will see whether or not there are any messages waiting to be executed in the calling thread. 
    Public Declare Function GetInputState Lib "user32" () As Int32
    Dim objMutex As Mutex

    Public Sub Main()
        mblnSplashDone = False

        ' Since I don't use the Application Framework, we have to turn on the XP/Vista Styles on here
        Application.EnableVisualStyles()

        ' Is another instance of this app already running?
        objMutex = New Mutex(False, "EHCalcV3")
        If objMutex.WaitOne(0, False) = False Then
            objMutex.Close()
            objMutex = Nothing
            MsgBox("Another instance of the application is running.", MsgBoxStyle.Information)
            Exit Sub
        End If

        ' Start Random Generator
        Randomize()

        ' Does user want Splash Screen Shown?
        If My.Settings.showSplash Then
            ' Show Splash Screen
            Dim frmSplashInstance As New frmSplash
            With frmSplashInstance
                .Splash = True
                .Timer.Enabled = True
                .Show()
            End With

            ' Do startup tasks
            StartUpTasks()

            ' Finish Splash
            While Not mblnSplashDone
                If GetInputState = 0 Then
                    Application.DoEvents()
                End If
            End While

            ' Put frmSplashInstance in the Trash
            frmSplashInstance.Close()
            frmSplashInstance = Nothing
        Else ' Nope, just do Startup Tasks and load program
            StartUpTasks()
        End If

        ' Load Main form
        Application.Run(frmMainInstance)

        ' Save settings if user wants them saved
        If mblnSaveSettings And Not mblnResetSettings Then
            SaveSettings()
        End If

    End Sub

    Public Sub LoadSettings()
        mblnSaveSettings = My.Settings.saveSettings
        mblnSaveLock = My.Settings.saveLock
    End Sub

    Public Sub SaveSettings()
        My.Settings.saveSettings = mblnSaveSettings
        My.Settings.saveLock = mblnSaveLock
        My.Settings.Save()
    End Sub

    ' This subprocedure determins if we use the system web browser or a specific
    ' web browser (such as firefox) that the user told us to use than uses it to
    ' launch the link.
    Public Sub openWebBrowser(ByVal link As String)
        If My.Settings.customBrowser Then
            Dim p As New ProcessStartInfo
            p.FileName = My.Settings.browserPath
            p.Arguments = link
            Process.Start(p)
        Else
            Process.Start(link)
        End If
    End Sub

    ' Tasks to perform at Startup regardless if the Splash screen is enabled or not
    Private Sub StartUpTasks()
        ' Load Settings
        LoadSettings()

        ' Load any Modules/Classes that need to be loaded ahead of time while splash is up
        frmMainInstance = New frmMain
    End Sub

End Module
